accounts/urls.py
from django.conf.urls.defaults import patterns, url

urlpatterns = patterns('accounts.views',
                        url(r'^profile/(?P<user_id>\d*)/$', 'profile'),
)
                       

qaa/urls.py
from django.conf.urls.defaults import patterns, include, url
from django.views.generic import DetailView
from qaa.models import Question

urlpatterns = patterns('',
                       url(r'^$', 'qaa.views.index'),
                       url(r'^[\w\-]+/(?P<pk>\d+)/[\w\-]+/$',
                           DetailView.as_view(
            model=Question)),
                       url(r'^ask/$', 'qaa.views.ask'),
                       url(r'^ask/submit/$', 'qaa.views.submit'),
)

urls.py
from django.conf.urls.defaults import patterns, include, url
from django.conf import settings
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.core.urlresolvers import reverse

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()

urlpatterns = patterns('',
    # Examples:
    # url(r'^$', 'seekgee.views.home', name='home'),
    # url(r'^seekgee/', include('seekgee.foo.urls')),

    # Uncomment the admin/doc line below to enable admin documentation:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
                           url(r'^login/', 'django.contrib.auth.views.login',
                               {'template_name': 'accounts/login.html'}),
                       url(r'^logout/$', 'django.contrib.auth.views.logout', {'next_page': '/',}),
                       url(r'^$', 'main.views.index'),
                       url(r'^questions/', include('qaa.urls')),
                       url(r'^admin/', include(admin.site.urls)),
                       url(r'^media/(?P<path>.*)$', 'django.views.static.serve',
                           {'document_root': settings.MEDIA_ROOT}),
                       url(r'^accounts/', include('accounts.urls')),
                       )
urlpatterns += staticfiles_urlpatterns()

accounts/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

@receiver(post_save, sender=User)
def register_profile(sender, **kwargs):
    Profile.objects.create(user=kwargs['instance'])

class Profile(models.Model):
    user = models.OneToOneField(User)
    questions_number = models.IntegerField(default=0)
    answers_number = models.IntegerField(default=0)

    def __unicode__(self):
        return self.user.username

main/models.py
from django.db import models

# Create your models here.

qaa/models.py
from django.db import models
from django.contrib.auth.models import User

class Category(models.Model):
    title = models.CharField(max_length=50)
    
    def __unicode__(self):
        return self.title

class Question(models.Model):
    title = models.CharField(max_length=100)
    desc = models.TextField('description')
    category = models.ForeignKey(Category)
    pub_date = models.DateTimeField()
    asked_by = models.OneToOneField(User, null=True)
    votes = models.IntegerField(default=0)

    def __unicode__(self):
        return self.title[:70]

class Answer(models.Model):
    question = models.ForeignKey(Question)
    answer = models.CharField(max_length=300)
    pub_date = models.DateTimeField()
    is_best = models.BooleanField('is best answer?')
    submitted_by = models.OneToOneField(User)

    def __unicode__(self):
        return self.answer[:70]

class Tag(models.Model):
    title = models.CharField(max_length=50)
    question = models.ManyToManyField(Question)

    def __unicode__(self):
        return self.title

accounts/views.py
from django.contrib.auth.models import User
from accounts.models import Profile
from django.shortcuts import render_to_response
from django.http import HttpResponse
from django.template import RequestContext

def profile(request, user_id=1):
    user = request.user
    try:
        profile = user.get_profile()
    except Profile.DoesNotExist:
        profile = Profile.objects.create(user=user)
    questions_number = profile.questions_number
    return render_to_response('accounts/profile.html', {'user': user, 'questions_number': questions_number})

main/views.py
from qaa.models import Question
from accounts.models import Profile
from django.shortcuts import render_to_response
from django.template import RequestContext

def index(request):
    latest_questions = Question.objects.all().order_by('-pub_date')[:5]
    most_active_profiles = Profile.objects.all().order_by('questions_number')[:5]
    return render_to_response('main/index.html', {'latest_questions': latest_questions, 'most_active_profiles': most_active_profiles}, context_instance=RequestContext(request))

qaa/views.py
from qaa.models import Question, Answer, Category
from django.shortcuts import get_object_or_404, render_to_response
from django.template import RequestContext
from django.http import HttpResponseRedirect
from django.core.urlresolvers import reverse
import datetime
from django.contrib.auth.decorators import login_required

def index(request):
    latest_questions = Question.objects.all().order_by('-pub_date')[:5]
    return render_to_response('qaa/questions.html', {'latest_questions': latest_questions}, context_instance=RequestContext(request))

@login_required
def ask(request):
    try:
        question_title = request.POST['question_title']
    except KeyError:
        question_title = None

    category_list = Category.objects.all()
    return render_to_response('qaa/ask.html', {'question_title': question_title,
                                               'category_list': category_list}, context_instance=RequestContext(request))

@login_required
def submit(request):
    user = request.user
    question_title = request.POST['title']
    question_desc = request.POST['description']
    category = Category.objects.get(pk=int(request.POST['category']))
    if ( not question_title ) or ( not question_desc ):
        error_message = 'You must fill all fields.'
        return render_to_response('qaa/ask.html', {'question_title': '',
                                            'error_message': error_message},
                           context_instance=RequestContext(request))
    else:
        q = Question.objects.create(title=question_title, desc=question_desc, pub_date=datetime.datetime.now(), category=category, asked_by=user)
        user.get_profile().questions_asked += 1
        return HttpResponseRedirect(reverse('qaa.views.index'))

templates/accounts/login.html
{% extends 'base.html' %}
{% load url from future %}

{% block content %}
	
	<form action="{% url 'django.contrib.auth.views.login' %}" method="post">
		{% csrf_token %}
		{{ form.as_p }}
		<input type="submit" value="Sign In" />
		<input type="hidden" name="next" value="{{ next }}" />
	</form>

{% endblock content %}

templates/accounts/profile.html
{% extends 'base.html' %}

{% block content %}
	<p>Questions number: {{ questions_number }}</p>
	<a href="/logout/" >Logout</a>
{% endblock content %}

templates/base.html
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html ; charset=utf-8"/>
	<link href="{{ STATIC_URL }}/css/style.css" rel="stylesheet" type="text/css"/>
	<title>Seekgee - {% block title %}{% endblock title %}</title>
</head>
<body>
	<div id='container'>
		
		<div id="topmenu">
			<div class="nav"><a href="/">Home</a></div>
			<div class="nav"><a href="/questions" >Questions</a></div>
		</div>
		
		<div id="main">
		
			<div id="rightmenu">
				<div class="nav">
				<h3>Main Menu</h3>

				<ul>
					<li><a href="index.html" >Home</a></li>
					<li><a href="articles.html" >Articles</a></li>
				</ul>
				</div>
				<hr  style="width: 70%;"/>
				<div class="nav">
					<h3>Friends</h3>
					<ul>
						<li><a href="http://lynda.com" >Lynda.com</a></li>
						<li><a href="http://cyberbotics.com" >Cyberbotics</a></li>

					</ul>

				</div>

			</div> <!-- end rightmenu -->
			
			<div id="content">
				{% block content %}
				{% endblock content %}	
			</div>
	

		</div> <!-- end main -->
	</div> <!-- end container -->
</body>
</html>

templates/main/index.html
{% extends 'base.html' %}

{% block content %}
	<div class="ask">
		<form action="/questions/ask/" method="post">{% csrf_token %}
			<input class="input_box" type="text" name="question_title" />
			<input class ="input_button" type="submit" value="Ask"  />
		</form>
	</div>

	<div class="article">
		<div class="title">Latest Questions</div>	
		{% for question in latest_questions %}
			<a href="/questions/{{ question.id }}/"  >{{ question.title }}</a>
		{% endfor %}
	</div>
	<div class="article">
		<div class="title">Most active users</div>
		{% for profile in most_active_profiles %}
			<a href="/accounts/profile/{{ profile.user.id }}/" >{{ profile.user.username }}</a>
		{% endfor %}	
	
	</div>
{% endblock content %}

templates/qaa/ask.html
{% extends 'base.html' %}
{% block title %}Ask your question!{% endblock title %}

{% block content %}
	{% if error_message %}<b style="color: red;">{{ error_message }}</b>{% endif %}
	<form action="/questions/ask/submit/" method="post">
		{% csrf_token %}
		Title: <input type="text" name="title" value="{% if question_title %}{{ question_title }}{% endif %}" /><br />
		Category: <select name="category" />
						{% for category in category_list %}
							<option value="{{ category.pk }}">{{ category.title }}</option>			
						{% endfor %}
					</select>
					<br />
		Description: <textarea name="description" ></textarea><br />
		<input type="submit" value="Submit" /> 

	</form>
	
{% endblock content %}

templates/qaa/question_detail.html
{% extends "base.html" %}
{% block title %}{{ question.title }}{% endblock %}
{% block content %}
<h3>{{ question.title }}</h3>
Publish date: {{ question.pub_date }}, Asked by: {{ question.asked_by }}
<p>{{ question.desc }}</p>
{% if question.answer_set.all %}
	<ul>
	{% for answer in question.answer_set.all %}
		<li>{{ answer.answer }}</li>
	{% endfor %}	
	</ul>
{% endif %}
{% if not question.answer_set.all %}
	<b>No answer found!</b>
{% endif %}
{% endblock content %}

templates/qaa/questions.html
{% extends "base.html" %}
{% block title %}Questions{% endblock title %}
{% block content %}

	<div class="ask">
		<form action="/questions/ask/" method="post">{% csrf_token %}
			<input class="input_box" type="text" name="question_title" />
			<input class ="input_button" type="submit" value="Ask"  />
		</form>
	</div>
	
	<br /><hr /><br />
	<div class="article">
		<div class="title">Last 5 questions: </div>
			{% if latest_questions %}
				<ul>
				{% for question in latest_questions %}
					<li><a href='/questions/{{ question.category|slugify }}/{{ question.id }}/{{ question.title|slugify }}/'>{{ question.title }}</a></li>
				{% endfor %}
				</ul>
			
			{% else %}
				<p>No questions are available.</p>
			{% endif %}
	</div>
{% endblock content %}